// rules.cpp: implementation of the rules class.
//
//////////////////////////////////////////////////////////////////////
#include "stdafx.h"
#include "rules.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

rules::rules()
{
	//constructor
	//this function update the array of the high
	for (int i=0;i<board_length;++i)
		high[i]=0;
}

void rules::options(the_list &list_1)
{
	//this function gets a list by referance
	//and update the list with the options
	list_1.delete_list();//deleting the list
	for (int i=0;i<board_length;++i)
	{
		if (high[i]<board_high)//if possible
			list_1.add(i);//add
	}
}

int rules::the_high(int line)
{
	//this function gets an integer number
	//returns the high in this column
	if (line<board_length)//if possible
		if (line>=0)//if possible
			return high[line];//return the high
	//else
	cout << "wrong the_high";//message worng
	return -1;//return -1
}

int rules::the_turn(state board)
{
	//this function gets state board
	//and returns the numbers of turn that played in the board
	int turn=0;//turn
	int j;//loap parameter
	for (int i=0;i<board_length;++i)//i from 0 to board_length-1
		for (j=0;j<board_high;++j)//j from 0 to board_high-1
			if (board.value(i,j)!=0)//if that place is played
				turn++;	//update turn
	return turn;//return turn
}

int rules::won(state board)
{
	//this function gets a state board
	//and returns if there is a winner the number of the winner
	//else return 0
	int j,i,l,r;//loap parameter
	for (int k=1;k<3;++k)//check if there is a winning in a line 
	{

		for (i=0;i<board_length/2+1;++i)
		{
			for (j=0;j<board_high;++j)
			{
				r=k;
				for (l=0;l<in_one_line;++l)
					if (board.value(i+l,j)!=k)
						r=0;
								
					if (r!=0)
						return r;
			}
		}
	}


	for (k=1;k<3;++k)//check if there is a winning in a coloumn
	{

		for (i=0;i<board_length;++i)
		{
			for (j=0;j<board_high/2;++j)
			{
				r=k;
				for (l=0;l<in_one_line;++l)
					if (board.value(i,j+l)!=k)
						r=0;
								
					if (r!=0)
						return r;
			}
		}
	}


	for (k=1;k<3;++k)//check if there is a winnig in the right alachson
	{

		for (i=0;i<board_length/2+1;++i)
		{
			for (j=0;j<board_high/2;++j)
			{
				

				r=k;
				for (l=0;l<in_one_line;++l)
					if (board.value(i+l,j+l)!=k)
						r=0;
								
					if (r!=0)
						return r;


			}
		}
	}

	for (k=1;k<3;++k)//check if there is a winnig in the left alachson 
	{

		for (i=board_length/2;i<board_length;++i)
		{
			for (j=0;j<board_high/2;++j)
			{

				r=k;
				for (l=0;l<in_one_line;++l)
					if (board.value(i-l,j+l)!=k)
						r=0;
								
					if (r!=0)
						return r;
				
			}
		}
	}
	return 0;//else return 0
}


void rules::update_high(state board)
{
	int j;
	int count;
	for (int i=0; i<board_length;++i)
	{
		count=0;
		for (j=0;j<board_high;++j)
		{
			if (board.value(i,j)!=0)
				count++;
		}
		high[i]=count;
	}
}