// state.h: interface for the state class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_STATE_H__1F93C2F8_8048_40FC_8A9F_63F1FF7C9CC5__INCLUDED_)
#define AFX_STATE_H__1F93C2F8_8048_40FC_8A9F_63F1FF7C9CC5__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

const int in_one_line=4;//games consts
const int board_length=in_one_line*2-1;//games consts
const int board_high=in_one_line*2-2;//games consts


#include <iostream.h>

class state  
{
	//this class save the board
private:
	int board[board_length][board_high]; //array of the board
public:
	
	state();//constructor puts 0 int the board
	void copy(int board1[board_length][board_high]);//copy a array to the board
	void move(int line,int high,int color);//play a move color in (line,high)
	void redo(int line,int high);//redo v move in (line,high)
	int value(int line,int column);	//return the value of the board in (line,column)

};

#endif // !defined(AFX_STATE_H__1F93C2F8_8048_40FC_8A9F_63F1FF7C9CC5__INCLUDED_)
