// testDlg.cpp : implementation file
//

#include "stdafx.h"
#include "test.h"
#include "testDlg.h"

#include <iostream.h>
#include <winuser.h>
#include "state.h"
#include "rules.h"
#include "conversions.h"
#include "server.h"
#include "client.h"
#include "the_list.h"
#include "Pro.h"
#include "Help1.h"


#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	virtual void OnOK();
	afx_msg void OnPaint();
	afx_msg HBRUSH OnCtlColor(CDC* pDC, CWnd* pWnd, UINT nCtlColor);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
	ON_WM_PAINT()
	ON_WM_CTLCOLOR()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CTestDlg dialog

CTestDlg::CTestDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CTestDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CTestDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CTestDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CTestDlg)
		// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CTestDlg, CDialog)
	//{{AFX_MSG_MAP(CTestDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_WM_RBUTTONDOWN()
	ON_WM_SIZE()
	ON_WM_LBUTTONDOWN()
	ON_WM_CTLCOLOR()
	ON_WM_LBUTTONUP()
	ON_WM_KEYDOWN()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CTestDlg message handlers

BOOL CTestDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CTestDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.


//global declaration
	state board;
	char msg[l];//parameters
	client pl(2);
	client pl1(3);
	client pl2(5);
	server ser(1);
	server ser1(4);
	server ser2(6);
	int type;
	int t=0;
	int xxx;
	int empty=1;
	int b=0;


	

int typing(char msg[l])
{
	//this function gets an array
	//and puts in the array the type of the game
	//it returns the number of the player (2 or 4)
	if (msg[0]=='1')
	{
		char x;
		if (xxx/10==1)
		{
			x='y';
		}
		else
		{
			x='n';
		}
		char y;
		char z='0';
		if (xxx%10==0)
		{
			y='y';
		}
		else
		{
			z=char(xxx%10-2+'0');
		}
		msg[0]=x;
		if (z-'0'<8&&z-'0'>=0)
			msg[1]=z+2;
		else
			msg[1]='9';
		msg[2]='\0';
		return 2;
	}
	return 4;
}











void CTestDlg::OnLButtonDown(UINT nFlags, CPoint point) 
{	
	//onLButtonDown(mouse)
	char info;
	char string[100];
	conversions con;
	// CDialog::OnLButtonDown(nFlags, point);
	if (empty==1)		//if not begin
	{
		sprintf(string,"press SPACE");
		AfxMessageBox(string, 0, 1); //message box
	}

	if (empty==0)
	{
		CRect rc;
		GetClientRect(&rc);
		int width = rc.Width()/board_length; 
		int pushed = int(point.x / width)+1;//pushed = column
		rules rule;
		the_list list;
		rule.update_high(board);//update rule
		rule.options(list);//update list
		con.play_array(pushed-1,msg);//conversion
		int a;
		if (list.possible(pushed-1)==0)//if not possible
		{
			return;
		}
		board.move(pushed-1,rule.the_high(pushed-1),rule.the_turn(board)%2+1);//play
		Invalidate();//update
		if (rule.won(board)==0)//if didnt win
		{
			sprintf(string,"wait");
			AfxMessageBox(string, 0, 1); //message box
		}
		
		if (type==2)//if player1
		{
			a=ser1.send(msg);//send msg
			if (a!=2)//if not succeed
			{
				return;//return
			}
			pl1.get(msg);//get board
		}
		else//if player2
		{
			a=ser2.send(msg);
			if (a!=2)
			{
				return;
			}
			pl2.get(msg);//get board
		}
		info=msg[0];//update info
		if (info=='w'||info=='l'||info=='t'||info=='e')//if end of game
		{
			empty=2;
			if (info=='e')//if the other player got out of the game
			{
				sprintf(string,"the other player lost connection");
				AfxMessageBox(string, 0, 1); //message box
				return ;//return
			}
			if (type==2)
			{
				pl1.get(msg);//get board
			}
			else
			{
				pl2.get(msg);//get board
			}
			con.array_board(msg,board);//conversion
			Invalidate();
			//msg of the type of the end of the game
			if (info=='w')
			{
				sprintf(string,"you won");
				AfxMessageBox(string, 0, 1); //message box
			}
			if (info=='l')
			{
				sprintf(string,"you lose");
				AfxMessageBox(string, 0, 1); //message box
			}
			if (info=='t')
			{
				sprintf(string,"teko");
				AfxMessageBox(string, 0, 1); //message box
			}
			return ;//return 1
		}
		con.array_board(msg,board);//coversion
		//cout << endl;
		//print(board);//print
		Invalidate();
	}
}




void CTestDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);

		
	}
	else
	{
		if (b==0)
		{
		
		// gives you the current screen size
		CRect rc;
	    GetClientRect(&rc);

		// CDialog::OnPaint();
		CPaintDC dc(this); // device context for painting
		
		
		// brush for grid
		CBrush brushGrid(RGB(255,255,255));
		CBrush OrigBrush;
		CBrush* pTempBrush = NULL;
		pTempBrush = (CBrush*)dc.SelectObject(&brushGrid);
		// Save original brush.
		OrigBrush.FromHandle((HBRUSH)pTempBrush);

		//brush for BK
		CBrush brushBK(RGB(100,90,255)); //creates the Background color
		pTempBrush = (CBrush*)dc.SelectObject(&brushBK);
		dc.Rectangle(rc.left, rc.top, rc.right, rc.bottom);
		
		//Brush for GRID
		pTempBrush = (CBrush*)dc.SelectObject(&brushGrid);
		// draw the grid
		int width = rc.Width()/board_length;
		int height = rc.Height()/board_high;
		for (int j(1); j < board_length /* header file for this const */; j++ ) {
			dc.MoveTo(rc.left + width*j, rc.top);
			dc.LineTo(rc.left + width*j, rc.bottom);
		}
		for (j=1; j<board_high; j++) {
			dc.MoveTo(rc.left, rc.top + height*j);
			dc.LineTo(rc.right, rc.top + height*j);
		}

/*
		CBrush brushYellow(RGB(255,255,0)); //yellow ellipse
		pTempBrush = (CBrush*)dc.SelectObject(&brushYellow);
		dc.Ellipse(width*(m),height*(6-(i+1)),width*(m+1),height*(6-i));
		 dc.SelectObject(&OrigBrush); // Reselect original brush into device context.
	
	   

	    CBrush brushRed(RGB(255,0,0)); //red ellipse
		pTempBrush = (CBrush*)dc.SelectObject(&brushRed);
		dc.Ellipse(width*(m),height*(6-(i+1)),width*(m+1),height*(6-i));
		dc.SelectObject(&OrigBrush);

        
*/      // converting the array(board)
        for (int i=0;i<board_high;i++)
		{
			for (int m=0;m<board_length;m++)
			{
		     if (board.value(m,i)==1)
			 {
		       CBrush brushRed(RGB(255,0,0)); //red ellipse
		       pTempBrush = (CBrush*)dc.SelectObject(&brushRed);
		       dc.Ellipse(width*(m),height*(board_high-(i+1)),width*(m+1),height*(board_high-i));
		       dc.SelectObject(&OrigBrush);
			 }
		     else if (board.value(m,i)==2)
			 {
               CBrush brushYellow(RGB(255,255,0)); //yellow ellipse
		       pTempBrush = (CBrush*)dc.SelectObject(&brushYellow);
		       dc.Ellipse(width*(m),height*(board_high-(i+1)),width*(m+1),height*(board_high-i));
		       dc.SelectObject(&OrigBrush); // Reselect original brush into device context.
			 }
			}
		
		}
		}
			if(b==1)
			{
				// gives you the current screen size
		CRect rc;
	    GetClientRect(&rc);

		// CDialog::OnPaint();
		CPaintDC dc(this); // device context for painting
		
		
		// brush for grid
		CBrush brushGrid(RGB(255,255,255));
		CBrush OrigBrush;
		CBrush* pTempBrush = NULL;
		pTempBrush = (CBrush*)dc.SelectObject(&brushGrid);
		// Save original brush.
		OrigBrush.FromHandle((HBRUSH)pTempBrush);

		//brush for BK
		CBrush brushBK(RGB(0,0,0)); //creates the Background color
		pTempBrush = (CBrush*)dc.SelectObject(&brushBK);
		dc.Rectangle(rc.left, rc.top, rc.right, rc.bottom);
		
		//Brush for GRID
		pTempBrush = (CBrush*)dc.SelectObject(&brushGrid);
		// draw the grid
		int width = rc.Width()/board_length;
		int height = rc.Height()/board_high;
		for (int j(1); j < board_length /* header file for this const */; j++ ) {
			dc.MoveTo(rc.left + width*j, rc.top);
			dc.LineTo(rc.left + width*j, rc.bottom);
		}
		for (j=1; j<board_high; j++) {
			dc.MoveTo(rc.left, rc.top + height*j);
			dc.LineTo(rc.right, rc.top + height*j);
		}

/*
		CBrush brushYellow(RGB(255,255,0)); //yellow ellipse
		pTempBrush = (CBrush*)dc.SelectObject(&brushYellow);
		dc.Ellipse(width*(m),height*(6-(i+1)),width*(m+1),height*(6-i));
		 dc.SelectObject(&OrigBrush); // Reselect original brush into device context.
	
	   

	    CBrush brushRed(RGB(255,0,0)); //red ellipse
		pTempBrush = (CBrush*)dc.SelectObject(&brushRed);
		dc.Ellipse(width*(m),height*(6-(i+1)),width*(m+1),height*(6-i));
		dc.SelectObject(&OrigBrush);

        
*/      // converting the array(board)
        for (int i=0;i<board_high;i++)
		{
			for (int m=0;m<board_length;m++)
			{
		     if (board.value(m,i)==1)
			 {
		       CBrush brushRed(RGB(0,255,0)); //red ellipse
		       pTempBrush = (CBrush*)dc.SelectObject(&brushRed);
		       dc.Ellipse(width*(m),height*(board_high-(i+1)),width*(m+1),height*(board_high-i));
		       dc.SelectObject(&OrigBrush);
			 }
		     else if (board.value(m,i)==2)
			 {
               CBrush brushYellow(RGB(255,0,255)); //yellow ellipse
		       pTempBrush = (CBrush*)dc.SelectObject(&brushYellow);
		       dc.Ellipse(width*(m),height*(board_high-(i+1)),width*(m+1),height*(board_high-i));
		       dc.SelectObject(&OrigBrush); // Reselect original brush into device context.
			 }
			}
		
		}
		}

	
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CTestDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CAboutDlg::OnOK() 
{
	// TODO: Add extra validation here
	
	CDialog::OnOK();
}

BEGIN_EVENTSINK_MAP(CTestDlg, CDialog)
    //{{AFX_EVENTSINK_MAP(CTestDlg)
	ON_EVENT(CTestDlg, IDC_COMMANDBUTTON1, 3 /* BeforeDragOver */, OnBeforeDragOverCommandbutton1, VTS_DISPATCH VTS_DISPATCH VTS_R4 VTS_R4 VTS_I4 VTS_DISPATCH VTS_I2)
	//}}AFX_EVENTSINK_MAP
END_EVENTSINK_MAP()

void CTestDlg::OnBeforeDragOverCommandbutton1(LPDISPATCH Cancel, LPDISPATCH Data, float X, float Y, long DragState, LPDISPATCH Effect, short Shift) 
{
	int newval=1;
	// TODO: Add your control notification handler code here
	
}

void CTestDlg::OnRButtonDown(UINT nFlags, CPoint point) 
{
	// TODO: Add your message handler code here and/or call default
	CAboutDlg dlg;
    dlg.DoModal();
	
	CDialog::OnRButtonDown(nFlags, point);
}


void CTestDlg::OnSize(UINT nType, int cx, int cy) 
{
	CDialog::OnSize(nType, cx, cy);

	Invalidate();
	// TODO: Add your message handler code here
	
}



HBRUSH CTestDlg::OnCtlColor(CDC* pDC, CWnd* pWnd, UINT nCtlColor) 
{
	HBRUSH hbr = CDialog::OnCtlColor(pDC, pWnd, nCtlColor);
	
	return hbr;
}

void CAboutDlg::OnPaint() 
{
	CPaintDC dc(this); // device context for painting
	
	// TODO: Add your message handler code here
	
	// Do not call CDialog::OnPaint() for painting messages
}

HBRUSH CAboutDlg::OnCtlColor(CDC* pDC, CWnd* pWnd, UINT nCtlColor) 
{
	HBRUSH hbr = CDialog::OnCtlColor(pDC, pWnd, RGB(0,0,255));
	
	
	return hbr;
}


void CTestDlg::OnKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags) 
{
	// TODO: Add your message handler code here and/or call default

	conversions con;
	if (nChar==VK_SPACE)
	{
		
		if (empty==1)
		{
			int a=ser.send("1");			//send 1
			if (a!=2)
				return ;
			pl.get(msg);			//get msg
			pl.~client();
			ser.~server();
			t=msg[0]-'0';
			if (t==1)
			{
				CPro dlg;
				dlg.DoModal();
				xxx=dlg.ret();
			}
			type=typing(msg);
			if (type==2)
			{
				pl2.~client();
				ser2.~server();
				a=ser1.send(msg);
				if (a!=2)
					return ;
				pl1.get(msg);
			}
			else
			{
				pl1.~client();
				ser1.~server();
				pl2.get(msg);
			}
			empty=0;
			con.array_board(msg,board);
			Invalidate();
			return ;
		}
		
	}
	char s[]="For help press home";
	switch (nChar)
	{
	case (VK_F1):
		
        AfxMessageBox(s, 0, 1);
		break;
	case (VK_F2):
		SetWindowText("4 In Line");
		break;
    case (VK_F3):
		SetWindowText("thank you bagon");
        break;
	case (VK_F4):
		b=(b+1)%2;
		Invalidate();
		break;
	}
	if (nChar==VK_HOME)
	{
		CHelp1 dlg;
		dlg.DoModal();
	}
	CDialog::OnKeyDown(nChar, nRepCnt, nFlags);
}
