// the_list.cpp: implementation of the the_list class.
//
//////////////////////////////////////////////////////////////////////

#include "the_list.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

the_list::the_list()
{
	//constructor
	//this function starts list1
	list1=NULL;
}


void the_list:: add(int num)
{
	//this function gets an integer number
	//and adds this number to the list
	if ((num<board_length)&&(num>=0))
	{
		list*list2=list1;
		if (list2==NULL)
		{
			list1=new list;
			list1->number=num;
			list1->next=NULL;
			return;
		}
		while (list2->next!=NULL)
		{
			list2=list2->next;
		}
		list*list3=new list;
		list3->number=num;
		list3->next=NULL;
		list2->next=list3;
	}
	return;
}


int the_list:: possible(int num)
{
	//precondition-this function gets an int number
	//postcondition-return 1 if the number in the list
	//else return 0
	if ((num<board_length)&&(num>=0))
	{
		for (list*list2=list1;list2!=NULL;list2=list2->next)	//while not end of list
		{
			if(list2->number==num)								//if num found
			{
				return 1;
			}//return positive
		}
	}
	return 0;	//return negative

}



the_list::~the_list()
{
	//delete the list
	list*list2=list1;
	while (list1!=NULL)
	{
		list2=list1->next;
		if (list2!=NULL)
		{
			list1->next=list2->next;
			delete (list2);
		}
		else
		{
			list2=list1;
			delete(list2);
			list1=NULL;
		}
	}
}



void the_list::delete_list()
{
	//delete the list
	for (list*list2=list1;list2!=NULL;list2=list1)
	{
		list1=list1->next;
		delete(list2);
	}
}