// client.cpp: implementation of the client class.
//
//////////////////////////////////////////////////////////////////////
#include "stdafx.h"
#include "client.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

client::client(int i)
{
	//construction
	//this function gets integer i and build a pipe in the i th place
	

	char x[21]="\\\\.\\pipe\\SamplePipe";
	x[19]=char(i+'0');
	x[20]='\0';
	LPTSTR lpszPipename = x;
	hPipe = CreateNamedPipe ( lpszPipename, 
                                                 PIPE_ACCESS_DUPLEX, // read/write access 
                                                 PIPE_TYPE_MESSAGE | // message type pipe 
                                                 PIPE_READMODE_MESSAGE | // message-read mode 
                                                 PIPE_WAIT, // blocking mode 
                                                 PIPE_UNLIMITED_INSTANCES, // max. instances 
                                                 BUFSIZE, // output buffer size 
                                                 BUFSIZE, // input buffer size 
                                                 PIPE_TIMEOUT, // client time-out 
                                                 NULL); // no security attribute 

}

client::~client()
{
	//distruction
	//close the handle
	CloseHandle(hPipe);
}






void client::get(char x[l])
{
	//this function waits untill a server send a message
	//returns the meesage in array x
	BOOL fConnected; 
	CHAR chRequest[BUFSIZE]; 
	DWORD cbBytesRead; 
	BOOL fSuccess; 
	if (hPipe == INVALID_HANDLE_VALUE) 
		return;
	while (1)	//always
	{ 
		// Trying connectnamedpipe in sample for CreateNamedPipe
		// Wait for the client to connect; if it succeeds, 
		// the function returns a nonzero value. If the function returns 
		// zero, GetLastError returns ERROR_PIPE_CONNECTED. 
		fConnected = ConnectNamedPipe(hPipe, NULL) ? 
			TRUE : (GetLastError() == ERROR_PIPE_CONNECTED); 
		if (fConnected) //if connected
		{ 
			fSuccess = ReadFile (hPipe, // handle to pipe 
								chRequest, // buffer to receive data 
								BUFSIZE, // size of buffer 
								&cbBytesRead, // number of bytes read 
								NULL); // not overlapped I/O 
			chRequest[cbBytesRead] = '\0';
			printf("Data Received: %s\n",chRequest);
			//if (! fSuccess || cbBytesRead == 0) 
				break; 
			FlushFileBuffers(hPipe); 
			DisconnectNamedPipe(hPipe); 
		}
	}
	transport(chRequest,x ); //x=chRequest
	return; 
}



void client::transport(char a[],char b[])
{
	//this function gets two arrays
	//and copy aaray a to array b
	
	for (int i=0;a[i]!='\0';++i)
	{	
		b[i]=a[i];
	}
	b[i]='\0';
	return;
}
