
#include <iostream.h>
#include "client.h"
#include "conversions.h"
#include "rules.h"
#include "server.h"
#include "state.h"
#include "the_list.h"
#include "comp1.h"


void winner(int win);//prints the name of the winner
void print(state board);//print board for checking

int main()
{
	cout << "server is running" << endl;
	char msg[l];
	client pl(1);			//global client 
	client pl1(4);			//client player 1

	pl.get(msg);			//wait till player 1 send
	cout << "player1 got in" << endl;
	msg[0]='1';	
	msg[1]='\0';	
	server ser2(2);			//global client 
	ser2.send(msg);			//send type of player
	server s1(3);			//server 1
	pl1.get(msg);			//get type of game
	int start=1;			//who first
	if (msg[0]=='y')
	{
		start=0;			//correcting who first
	}
	char y=msg[1];
	client plx(1);
	client pl2(6);			//client player 2
	if (y=='2')
	{
		plx.get(msg);			//wait till player 2 send
		cout << "player2 got in" << endl;
		msg[0]=y;
		msg[1]='\0';
		server ser2x(2);		//global server
		ser2x.send(msg);		//send type of player
	}
	server s2(5);			//server 2
	comp1 comp;
	
	if (y!='2')
	{
		s2.~server();
		pl2.~client();
	}
	the_list list;			//parameters
	int move;				//parameters
	state board;			//parameters
	rules rule;				//parameters
	int turn=0;				//parameters
	int win=0;				//parameters
	conversions con;		//parameters
//	print(board);			//print
	rule.options(list);		// update list
	int exit;
		
	while (turn<board_length*board_high&&win==0)	//while playing
	{
//		cout << "turn= " <<  turn;
//		cout << endl;
		con.board_array(board,msg);			//conversion
			
		if (y=='2')
		{
			
			if ((turn+start)%2==0)				//if turn of player 1
			{
				exit =s1.send(msg);					//send board
				if (exit==1)
				{
					pl1.get(msg);					//get play
				}						
				else
				{
					s2.send("e");
					return 1;
				}
				con.array_play(msg,move);			//conversion
			}
			else								//if turn of player 2
			{
				exit=s2.send(msg);					//send board
				if (exit==1)
					pl2.get(msg);					//get play
				else
				{
					s1.send("e");
					return 1;
				}
				con.array_play(msg,move);			//conversion
			}
		}
		else
		{

			if ((turn+start)%2==0)				//if turn of player 1
			{
				exit =s1.send(msg);					//send board
				if (exit==1)
					pl1.get(msg);					//get play
				else
				{
					s2.send("e");
					return 1;
				}
				con.array_play(msg,move);			//conversion
			}
			else
			{				
				if (y-'2'>=1&&y-'2'<=7)
					move=comp.the_move(board,y-'2');//minimax
				else
					move=comp.the_move(board,7);//minimax
			}
		}

		
		if (list.possible(move)==1)			//if possible
		{
			board.move(move,rule.the_high(move),turn%2+1);			//play
			cout << "player" <<turn%2+1 << " played " << move+1 << endl;			//message
			turn++;							//update turn
			rule.update_high(board);		//update high
			rule.options(list);				//update options
//			print(board);					//print
		}
		win=rule.won(board);				//check for victory
	}
	winner(win);							//cout << the winner is:
	if (win==0)			//if no one wins
	{
		if (y=='2')
			s2.send("t");	//send teko
		s1.send("t");	//send teko
	}					
	if (win==1)			//if 1 won
	{
		if (start==0)	
		{
			s1.send("w");
			if (y=='2')
				s2.send("l");
		}
		if (start==1)
		{
			s1.send("l");
			if (y=='2')
				s2.send("w");
		}
	}
	if (win==2)			//if 2 won
	{
		if (start==0)
		{
			s1.send("l");
			if (y=='2')
				s2.send("w");
		}
		if (start==1)
		{
			s1.send("w");
			if (y=='2')
				s2.send("l");
		}
	}
	con.board_array(board,msg);		//conversion
	if (y=='2')
		s2.send(msg);					//send board
	s1.send(msg);					//send board
	return win;						//return
}

void winner(int win)
{
	//this function gets an int number
	//and print the winner
	if (win==0)
		cout << endl << "no one won" <<endl;
	if (win==1)
		cout << endl << "player1 won" << endl;
	if (win==2)
		cout << endl << "player2 won" << endl;
}

void print(state board)
{
	//this function gets a state board
	//and print the board
	int j;
	for (int i=1;i<=board_high;++i)
	{
		for (j=0;j<board_length;++j)
		{
			if (board.value(j,board_high-i)==0)
				cout << "  -  ";
			if (board.value(j,board_high-i)==1)
				cout << "  x  ";
			if (board.value(j,board_high-i)==2)
				cout << "  0  ";
		}
		cout<< endl;
	}
}




