// server.cpp: implementation of the server class.
//
//////////////////////////////////////////////////////////////////////
#include "stdafx.h"
#include "server.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

server::server(int i)
{
	//constuctor
	//this function gets an int number
	//and build a pipe in the number's place
	//and save this place in the hfile of the class
	char x[21]="\\\\.\\pipe\\SamplePipe";//create array
	x[19]=char(i+'0');//i' place
	x[20]='\0';//end of string
	hFile = CreateFile(x, GENERIC_WRITE,
						0, NULL, OPEN_EXISTING,
						0, NULL);//create pipe
}


 int server::send(char x[l])
{
	//this function gets a char array
	//and sends it in the pipe
	
	BOOL flg;//parameter
	DWORD dwWrite;//parameter
	
	
	if(hFile == INVALID_HANDLE_VALUE)
	{ 
		cout << ("CreateFile failed for Named Pipe client\n" );
		return 0;
	}
	else
	{
		flg = WriteFile(hFile,x, strlen(x), &dwWrite, NULL);
		if (FALSE == flg)//if not succeeded 
		{	
			//
			cout<< ("WriteFile failed for Named Pipe client\n");
			return 1;

		}
		else//if succeeded 
		{
//			cout << ("WriteFile succeeded for Named Pipe client\n");
//			cout << x;
			return 2;
		}
		
	}	
	
}


server::~server()
{
	//disructor
	//this function closes the handle

	CloseHandle(hFile);

}

